//
//  ES1Renderer.h
//  Snake
//
//  Created by Vahid Kazemi on 7/12/10.
//  Copyright KTH 2010. All rights reserved.
//

#import "ESRenderer.h"
#import "Vector.h"

#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

@interface ES1Renderer : NSObject <ESRenderer>
{
@private
    EAGLContext *context;

    // The pixel dimensions of the CAEAGLLayer
    GLint backingWidth;
    GLint backingHeight;

    // The OpenGL ES names for the framebuffer and renderbuffer used to render to this view
    GLuint defaultFramebuffer, colorRenderbuffer;
	
	GLuint texture;
	
	Vector3f accel;
}

- (void)render;
- (BOOL)resizeFromLayer:(CAEAGLLayer *)layer;
- (GLuint)loadTexture:(NSString *)filename;

@end
