//
//  Snake.h
//  Snake
//
//  Created by Vahid Kazemi on 7/13/10.
//  Copyright 2010 KTH. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Vector.h"
#import "SnakeBlock.h"

typedef enum {
	kDirLeft,
	kDirUp,
	kDirDown,
	kDirRight,
} Directions;

@interface Snake : NSObject {
	NSMutableArray* blocks;
	Vector2i dir;
	int tail;
	bool die;
	int no;
}

@property (retain, nonatomic) NSMutableArray* blocks;
@property Vector2i dir;
@property Vector3f color;
@property int tail;
@property bool die;
@property int no;

- (id) initWithID: (int)n Dir:(int)d fromX: (int)x1 andY: (int)y1 toX: (int)x2 andY:(int)y2;
+ (Vector2i) getDirByID: (int)d;

@end
