//
//  Snake.m
//  Snake
//
//  Created by Vahid Kazemi on 7/13/10.
//  Copyright 2010 KTH. All rights reserved.
//

#import "Snake.h"


@implementation Snake

@synthesize blocks;
@synthesize dir;
@synthesize color;
@synthesize tail;
@synthesize die;
@synthesize no;

- (id) initWithID: (int)n Dir:(int)d fromX: (int)x1 andY: (int)y1 toX: (int)x2 andY:(int)y2{
    if ((self = [super init]))
	{
        dir = [Snake getDirByID:d];
		blocks = [[NSMutableArray alloc] init];
		SnakeBlock* b = [[SnakeBlock alloc] initWithX:x1 andY:y1];
		[blocks addObject:b];
        [b release];
		die = false;
		tail = 0;
		no = n;
		
		while(x1!=x2){
			x1 += SIGN(x2-x1);
			b = [[SnakeBlock alloc] initWithX:x1 andY:y1];
			[blocks addObject:b];
            [b release];
		}
		
		while(y1!=y2){
			y1 += SIGN(y2-y1);
			b = [[SnakeBlock alloc] initWithX:x1 andY:y1];
            [blocks addObject:b];
            [b release];
		}
	}
	return self;
}

+ (Vector2i) getDirByID:(int)d {
	Vector2i tempDir;
	switch (d) {
		case kDirLeft:
			set2i(&tempDir,-1, 0);
			break;
		case kDirRight:
			set2i(&tempDir, 1, 0);
			break;
		case kDirUp:
			set2i(&tempDir, 0,-1);
			break;
		case kDirDown:
			set2i(&tempDir, 0, 1);
			break;
	}
	return tempDir;
}

- (void) dealloc {
	while(blocks.count>0){
		[blocks removeLastObject];
	}
	[blocks release];
	[super dealloc];
}


@end
