//
//  SoundMgr.m
//  Snake
//
//  Created by Vahid Kazemi on 7/15/10.
//  Copyright 2010 KTH. All rights reserved.
//

#import "SoundMgr.h"


@implementation SoundMgr


- (id)init {
	if(self=[super init]){
		NSString* filenames[] = {
			@"eat.wav", 
			@"rotate.wav", 
			@"merge.wav", 
			@"crash.wav",
			@"snake.wav",
			@"viper.wav",
			@"elapid.wav",
			@"python.wav",
			@"boa.wav",
			@"dragon.wav",
			@"mog.wav",
			@"music.mp3"};
		
		for(int i=0; i<kNumSounds; i++){
			NSURL *url = [NSURL fileURLWithPath:
						  [NSString stringWithFormat:@"%@/%@", 
						   [[NSBundle mainBundle] resourcePath], filenames[i]]];
			player[i] = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:nil];
			if(i<kSoundSnake)player[i].volume = 0.2;
			state[i] = false;
		}
	}
	player[kSoundBackground].numberOfLoops = -1;
	return self;
}

- (void)dealloc {
	for(int i=0; i<kNumSounds; i++){
		[player[i] release];
		player[i] = nil;
	}
	[super dealloc];
}

- (void) play: (int)soundID {
	[player[soundID] play];
	state[soundID] = true;
}

- (void) pause: (int)soundID {
	[player[soundID] pause];
	state[soundID] = false;
}

- (void)audioPlayerDidFinishPlaying:(AVAudioPlayer *)cplayer successfully:(BOOL)flag {
	for(int i=0; i<kNumSounds; i++){
		if(player[i]==cplayer){
			state[i] = false;
			break;
		}
	}
}

- (void)audioPlayerBeginInterruption:(AVAudioPlayer *)cplayer {
	[cplayer pause];
}

- (void)audioPlayerEndInterruption:(AVAudioPlayer *)cplayer {
	[cplayer play];
}


@end
